<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Determine displayed width of `char` and `str` types according to Unicode Standard Annex #11 rules."><meta name="keywords" content="rust, rustlang, rust-lang, unicode_width"><title>unicode_width - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="icon" href="https://unicode-rs.github.io/unicode-rs_sm.png"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../unicode_width/index.html"><div class="logo-container"><img src="https://unicode-rs.github.io/unicode-rs_sm.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../unicode_width/index.html"><div class="logo-container">
                    <img src="https://unicode-rs.github.io/unicode-rs_sm.png" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate unicode_width</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.1.9</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#constants">Constants</a></li><li><a href="#traits">Traits</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../unicode_width/index.html">
                        <img src="https://unicode-rs.github.io/unicode-rs_sm.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">unicode_width</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/unicode_width/lib.rs.html#11-131">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Determine displayed width of <code>char</code> and <code>str</code> types according to
<a href="http://www.unicode.org/reports/tr11/">Unicode Standard Annex #11</a>
rules.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">unicode_width</span>;

<span class="kw">use</span> <span class="ident">unicode_width::UnicodeWidthStr</span>;

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="kw">let</span> <span class="ident">teststr</span> <span class="op">=</span> <span class="string">&quot;Ｈｅｌｌｏ, ｗｏｒｌｄ!&quot;</span>;
    <span class="kw">let</span> <span class="ident">width</span> <span class="op">=</span> <span class="ident">UnicodeWidthStr::width</span>(<span class="ident">teststr</span>);
    <span class="macro">println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">teststr</span>);
    <span class="macro">println!</span>(<span class="string">&quot;The above string is {} columns wide.&quot;</span>, <span class="ident">width</span>);
    <span class="kw">let</span> <span class="ident">width</span> <span class="op">=</span> <span class="ident">teststr</span>.<span class="ident">width_cjk</span>();
    <span class="macro">println!</span>(<span class="string">&quot;The above string is {} columns wide (CJK).&quot;</span>, <span class="ident">width</span>);
}</code></pre></div>
<h2 id="features"><a href="#features">features</a></h2>
<p>unicode-width supports a <code>no_std</code> feature. This eliminates dependence
on std, and instead uses equivalent functions from core.</p>
<h2 id="cratesio"><a href="#cratesio">crates.io</a></h2>
<p>You can use this package in your project by adding the following
to your <code>Cargo.toml</code>:</p>
<div class="example-wrap"><pre class="language-toml"><code>[dependencies]
unicode-width = &quot;0.1.5&quot;</code></pre></div></div></details><h2 id="constants" class="small-section-header"><a href="#constants">Constants</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="constant" href="constant.UNICODE_VERSION.html" title="unicode_width::UNICODE_VERSION constant">UNICODE_VERSION</a></div><div class="item-right docblock-short"><p>The version of <a href="http://www.unicode.org/">Unicode</a>
that this version of unicode-width is based on.</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.UnicodeWidthChar.html" title="unicode_width::UnicodeWidthChar trait">UnicodeWidthChar</a></div><div class="item-right docblock-short"><p>Methods for determining displayed width of Unicode characters.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.UnicodeWidthStr.html" title="unicode_width::UnicodeWidthStr trait">UnicodeWidthStr</a></div><div class="item-right docblock-short"><p>Methods for determining displayed width of Unicode strings.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="unicode_width" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>